#Set Numbers
scoreboard players set 2 tdWave 2
scoreboard players set -5 tdWave -5
scoreboard players set 3 tdWave 3
scoreboard players set 0 tdWave 0
#Next Wave Item
scoreboard players tag @a add wave_start_item {Inventory:[{tag:{display:{LocName:"Next Wave"}}}]}
clear @a carrot_on_a_stick -1 64 {display:{LocName:"Next Wave"}}
#General
scoreboard players add number tdWave 1
scoreboard players set running tdStats 1
scoreboard players operation difficulty tdWave = number tdWave
execute @e[tag=td_tower] ~ ~ ~ scoreboard players add difficulty tdWave 1
tellraw @a ["",{"text":"[","color":"dark_gray"},{"text":"TS","color":"dark_red","obfuscated":true},{"text":"] ","color":"dark_gray"},{"text":"Wave ","color":"gray"},{"score":{"name":"number","objective":"tdWave"},"color":"gray"}]
execute @e[tag=next] ~ ~ ~ setblock ~ ~ ~ air
scoreboard players operation Victory tdInfo = victory tdWave
#Balance Difficulty based on Wave
scoreboard players test difficulty tdWave 2 60
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players remove difficulty tdWave 1
scoreboard players test difficulty tdWave 7 30
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players remove difficulty tdWave 2
scoreboard players test difficulty tdWave 15 35
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players remove difficulty tdWave 3
scoreboard players test difficulty tdWave 5 40
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players remove difficulty tdWave 2
scoreboard players test difficulty tdWave 25 45
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players remove difficulty tdWave 3
scoreboard players test difficulty tdWave 20 50
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players remove difficulty tdWave 2
#Balance Difficulty based on Health
scoreboard players set minus tdWave 10
scoreboard players test level tdStats 1 99
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players operation minus tdWave -= Lives tdInfo
scoreboard players operation minus tdWave /= 2 tdWave
scoreboard players test difficulty tdWave 10 130
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players operation difficulty tdWave -= minus tdWave
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players test level tdStats 10 10
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players operation difficulty tdWave += minus tdWave
#Balance Difficulty based on last live lost
scoreboard players test number tdWave -1000 10
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players operation lost tdWave > 0 tdWave
scoreboard players test number tdWave -1000 15
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players operation lost tdWave > -5 tdWave
scoreboard players add lost tdWave 1
scoreboard players operation difficulty tdWave += lost tdWave
execute @s ~ ~ ~ scoreboard players test difficulty tdWave -1000 0
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players set difficulty tdWave 2
#Change Difficulty based on extra 
scoreboard players test number tdWave 3
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players operation difficulty tdWave += extra tdWave
#Change Difficulty based on sandbox settings
scoreboard players operation difficulty tdWave += sand tdWave
#Difficulty Minimum Limit
scoreboard players operation limit tdWave = number tdWave
scoreboard players operation limit tdWave /= 3 tdWave
#Avoid 0 Waves
scoreboard players test difficulty tdWave 0 0
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players set difficulty tdWave 2
#Tower Abilities
scoreboard players operation Gold tdInfo += @e[score_tdGold_min=1] tdGold
scoreboard players add @e[tag=td_tower,score_tdTower=15,score_tdTower_min=15] tdGold 2
execute @e[tag=td_tower,score_tdTower=15,score_tdTower_min=15] ~ ~ ~ particle totem ~ ~1.5 ~ 1 1 1 0 100
execute @e[score_tdHeal_min=1] ~ ~ ~ scoreboard players operation @e[tag=td_tower,r=10,score_tdTower_min=1] tdTowerH += @s tdHeal
execute @e[score_tdHeal_min=1] ~ ~ ~ execute @e[tag=td_tower,r=10,score_tdTower_min=1] ~ ~ ~ particle heart ~ ~1 ~ 0.5 0.5 0.5 0 10
#Tower Other
execute @e[tag=td_tower] ~ ~ ~ detect ~ ~-1 ~ coal_ore 0 scoreboard players add @s tdQuicksand 1
scoreboard players set @e[tag=td_tower,score_tdQuicksand_min=15] tdTowerH 0
scoreboard players tag @e[tag=zephyr_frozen] remove tower_frozen
scoreboard players tag @e[tag=zephyr_frozen] remove zephyr_frozen
execute @e[tag=td_tower]  ~ ~ ~ scoreboard players operation @s tdCooldown = @s tdCooldownSave
scoreboard players set @e[tag=td_tower] tdCooldown 10
#Auto Tower Heal
scoreboard players test difficulty tdWave 40
execute @s[score_Success_min=1] ~ ~ ~ scoreboard players add @e[tag=td_tower,score_tdTowerH=5] tdTowerH 1
#Functions
scoreboard players tag @e[tag=area_main] remove wr
execute @s ~ ~ ~ function mechanic:wave_speed
execute @s ~ ~ ~ function mechanic:wave_segment_main
execute @e[tag=spawn] ~ ~ ~ summon minecraft:zombie ~ ~ ~ {Tags:["td_enemy","tdh2"],NoAI:1,Invulnerable:1,CustomNameVisible:1,ArmorItems:[{},{},{},{id:leather_helmet,Count:1}]}

